---
driver number: 0x00000
---

# Alarm

## Overview

The alarm driver exposes a wrapping hardware counter to processes. An alarm can
report the current tic value and notify via a callback when the counter reaches
a certain value.

The alarm's frequency is platform-specific, but must be _at least_ 1kHz.

## Command

  * ### Command number: `0`

    **Description**: Does the driver exist?

    **Argument 1**: unused

    **Argument 2**: unused

    **Returns**: The number of concurrent notifications supported per process,
    0 if unbounded, otherwise ENODEVICE

  * ### Command number: `1`

    **Description**: Returns the clock frequency of the alarm.

    **Argument 1**: unused

    **Argument 2**: unused

    **Returns**: The frequency in Hertz.

  * ### Command number: `2`

    **Description**: Read the current counter tic value.

    **Argument 1**: unused

    **Argument 2**: unused

    **Returns**: The counter value in tics.

  * ### Command number: `3`

    **Description**: Stop an outstanding alarm notification.

    **Argument 1**: Alarm notification identifer as returned from command 4.

    **Argument 2**: unused

    **Returns**: EINVAL if the notification identifier is invalid, EALREADY if
    the notification is already disabled, or SUCCESS.

  * ### Command number: `4`

    **Description**: Set an alarm notification for a counter value.
    Notification invokes the callback set with subscribe.

    **Argument 1**: The counter tic value to notifity.

    **Argument 2**: unused

    **Returns**: EINVAL if the notification identifier is invalid, EALREADY if
    the notification is already disabled, or SUCCESS.

## Subscribe

  * ### Subscribe number: `0`

    **Description**: Subscribe to alarm notifications.

    **Callback signature**: The callback recieves two arguments: the counter
    tic value when the alarm notifiation expired and the notification
    identifier returned from command 4. The value of the remaining argument is
    undefined.

    **Returns**: SUCCESS if the subscribe was successful or ENOMEM if the
    driver failed to allocate memory for the transaction.

